#version 120
// sharpen grain
uniform sampler2D adsk_results_pass2;
uniform float adsk_result_w, adsk_result_h;
uniform float sharpness;

vec2 res = vec2(adsk_result_w, adsk_result_h);

void main(void)
{
	vec2 uv = gl_FragCoord.xy / vec2( adsk_result_w, adsk_result_h);
	vec2 step = 1.0 / res.xy;
	vec3 texA = texture2D( adsk_results_pass2, uv + vec2(-step.x, -step.y) * 1.5 ).rgb;
	vec3 texB = texture2D( adsk_results_pass2, uv + vec2( step.x, -step.y) * 1.5 ).rgb;
	vec3 texC = texture2D( adsk_results_pass2, uv + vec2(-step.x,  step.y) * 1.5 ).rgb;
	vec3 texD = texture2D( adsk_results_pass2, uv + vec2( step.x,  step.y) * 1.5 ).rgb;
  vec3 around = 0.25 * (texA + texB + texC + texD);
	vec3 center  = texture2D( adsk_results_pass2, uv ).rgb;
	vec3 col = center + (center - around) * sharpness * 0.1;

  gl_FragColor = vec4(col,1.0);
}
